package com.ninexiu.sixninexiu.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.fragment.tencentim.TencentChatFragment
import com.thirdparty.utils.StatusBarUtil
import kotlinx.android.synthetic.main.activity_hello_chat.*

class HelloChatActivity :BaseActivity(){

    companion object{
        fun start(context:Context, bundle:Bundle){
            val intent=Intent(context,HelloChatActivity::class.java)
            intent.putExtra("bundle",bundle)
            context.startActivity(intent)
        }
    }

    override fun setContentView() {
        setContentView(R.layout.activity_hello_chat)
        StatusBarUtil.setTranslucentForImageViewInFragment(this, null)
        StatusBarUtil.setDarkMode(this)
    }

    override fun initViews() {
        super.initViews()
        val chatFragment=TencentChatFragment::class.java.newInstance()
        chatFragment.arguments=intent.getBundleExtra("bundle")
        supportFragmentManager.beginTransaction().replace(R.id.fl_chat_container, chatFragment).commit()



        cl_chat_root.setOnClickListener {
            finish()
            overridePendingTransition(0,0)
        }
    }
}