package com.ninexiu.sixninexiu.activity

import android.annotation.SuppressLint
import android.app.AlertDialog
import android.app.Dialog
import android.content.Context
import android.content.DialogInterface
import android.content.Intent
import android.graphics.Bitmap
import android.graphics.Color
import android.graphics.Paint
import android.net.ConnectivityManager
import android.net.Uri
import android.net.http.SslError
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.os.Message
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.text.method.LinkMovementMethod
import android.text.style.ForegroundColorSpan
import android.util.AttributeSet
import android.util.Log
import android.util.TypedValue
import android.view.View
import android.view.View.OnClickListener
import android.view.ViewGroup
import android.webkit.SslErrorHandler
import android.webkit.WebSettings
import android.webkit.WebView
import android.webkit.WebViewClient
import android.widget.TextView
import android.widget.Toast
import com.alipay.sdk.app.PayTask
import com.ninexiu.sixninexiu.BuildConfig
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.application.NineShowApplication
import com.ninexiu.sixninexiu.application.NineShowApplication.mUserBase
import com.ninexiu.sixninexiu.bean.RoomSystemMsgResultInfo
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.common.net.NSAsyncHttpClient
import com.ninexiu.sixninexiu.common.net.NSJsonResponseHandler
import com.ninexiu.sixninexiu.common.net.NSRequestParams
import com.ninexiu.sixninexiu.common.statistics.StatisticsEventID
import com.ninexiu.sixninexiu.common.statistics.StatisticsUtil
import com.ninexiu.sixninexiu.common.util.Constants
import com.ninexiu.sixninexiu.common.util.MyToast
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.NSReceiverAction
import com.ninexiu.sixninexiu.common.util.Utils
import com.ninexiu.sixninexiu.fragment.PersonalCenterFragment
import com.ninexiu.sixninexiu.pay.BaseHelper
import com.ninexiu.sixninexiu.pay.PayUtil
import com.ninexiu.sixninexiu.pay.PayUtil.CreateOrderListener
import com.ninexiu.sixninexiu.pay.PayUtil.NotifyUserInfoListener
import com.ninexiu.sixninexiu.pay.PayUtil.OrderRequest
import com.ninexiu.sixninexiu.pay.ResultChecker
import com.ninexiu.sixninexiu.pay.WXPay
import com.ninexiu.sixninexiu.values.Global
import com.ninexiu.sixninexiu.view.dialog.DiscountSuccessDialog
import com.ninexiu.sixninexiu.view.dialog.ParentsModleHintDialog
import com.thirdparty.utils.StatusBarUtil
import com.unionpay.UPPayAssistEx
import com.unionpay.uppay.PayActivity
import kotlinx.android.synthetic.main.activity_discountcard.disount_btn_buy
import kotlinx.android.synthetic.main.activity_discountcard.disount_iv_wx
import kotlinx.android.synthetic.main.activity_discountcard.disount_iv_yl
import kotlinx.android.synthetic.main.activity_discountcard.disount_iv_zf
import kotlinx.android.synthetic.main.activity_discountcard.disount_title
import kotlinx.android.synthetic.main.activity_discountcard.disount_tv_agomoney
import kotlinx.android.synthetic.main.activity_discountcard.disount_tv_balance
import kotlinx.android.synthetic.main.activity_discountcard.disount_tv_fitstrecharge
import kotlinx.android.synthetic.main.activity_discountcard.disount_tv_rechargeaccount
import kotlinx.android.synthetic.main.activity_discountcard.disount_tv_rechargeresult
import kotlinx.android.synthetic.main.activity_discountcard.disount_tv_resultmoney
import kotlinx.android.synthetic.main.activity_discountcard.pay_checked_1
import kotlinx.android.synthetic.main.activity_discountcard.pay_checked_2
import kotlinx.android.synthetic.main.activity_discountcard.pay_checked_3
import kotlinx.android.synthetic.main.title_tab_bar.left_btn
import kotlinx.android.synthetic.main.title_tab_bar.right_tv
import org.json.JSONException
import org.json.JSONObject
import java.util.HashMap
import android.text.style.ClickableSpan as ClickableSpan1

/**
 * <pre>
 * @author : wangyu
 * time   : 2019/12/17
 * desc   : 充值使用折扣卡Activity
 * version: 3.9.5.4
</pre> *
 */
class ZhifuDiscountActivity : BaseActivity(), OnClickListener {

    private var payUtil: PayUtil? = null
    private var agoMoney: Int = 0
    private var relustMoney: Int = 0
    private var chargeRid :String? = null//折扣卡Id

    private var mDialog: Dialog? = null
    private var pay_webview: WebView? = null
    private var orderId: String? = null //服务端返回的签名数据
    private var param: String? = null //服务端返回的签名数据
    private var isNoCallBackPay = false //是不是没有回调的支付方式。
    private var isClikcPayBtn = true //一次点击支付对应一次调起
    private var balance: String? = null
    private var isUPPay = false
    private var chargeType: Int = 0 // 110：支付宝官方;126：微信官方;114：手机银联(android); 146：快付微信 163 银联闪付宝

    // 这里接收支付结果，支付宝手机端同步通知
    @SuppressLint("HandlerLeak")
    private val mHandler = object : Handler() {

        override fun handleMessage(msg: Message) {

            try {
                val strRet = msg.obj as String
                // strRet范例：resultStatus={9000};memo={};result={partner="2088201564809153"&seller="2088201564809153"&out_trade_no="050917083121576"&subject="123456"&body="2010新款NIKE 耐克902第三代板鞋 耐克男女鞋 386201 白红"&total_fee="0.01"&notify_url="http://notify.java.jpxx.org/index.jsp"&success="true"&sign_type="RSA"&sign="d9pdkfy75G997NiPS1yZoYNCmtRbdOP0usZIMmKCCMVqbSG1P44ohvqMYRztrB6ErgEecIiPj9UldV5nSy9CrBVjV54rBGoT6VSUF/ufjJeCSuL510JwaRpHtRPeURS1LXnSrbwtdkDOktXubQKnIMg2W0PreT1mRXDSaeEECzc="}
                when (msg.what) {
                    PayUtil.MSG_ZHIFUBAO -> { //支付宝支付成功的结果处理（支付宝官方）
                        // 处理交易结果
                        try {
                            // 获取交易状态码，具体状态代码请参看文档
                            var tradeStatus = "resultStatus={"
                            var imemoStart = strRet.indexOf("resultStatus=")
                            imemoStart += tradeStatus.length
                            val imemoEnd = strRet.indexOf("};memo=")
                            tradeStatus = strRet.substring(imemoStart, imemoEnd)
                            // 先验签通知
                            val resultChecker = ResultChecker(strRet)
                            val retVal = resultChecker.checkSign()
                            // 验签失败
                            if (retVal == ResultChecker.RESULT_CHECK_SIGN_FAILED) {
                                BaseHelper.showDialog(this@ZhifuDiscountActivity,
                                    "提示",
                                    this@ZhifuDiscountActivity.resources.getString(R.string.check_sign_failed),
                                    android.R.drawable.ic_dialog_alert)
                            } else { // 验签成功。验签成功后再判断交易状态码
                                if (tradeStatus == "9000") { // 判断交易状态码，只有9000表示交易成功
                                    //								Log.e(TAG, " ------   支付成功       -------   ");
                                    // 一键注册充值，强制进行更改帐号密码
                                    //                                    if (NineShowApplication.mUserBase != null && NineShowApplication.isUseOnekeyReister() && !NineShowApplication.isChangeOnekeyReisterPwd()) {
                                    //                                        if (boundDialogUtils == null) {
                                    //                                            boundDialogUtils = new BoundDialogUtils();
                                    //                                        }
                                    //                                        boundDialogUtils.showOneKeyChangePwdDialog(ZhifuActivity.this);
                                    //                                    }
                                    NineShowApplication.setCharged(true)
                                    checkOrder()
                                } else {
                                    BaseHelper.showDialog(this@ZhifuDiscountActivity, "提示", "支付失败.", R.drawable.infoicon)
                                }


                            }
                        } catch (e: Exception) {
                            e.printStackTrace()
                            BaseHelper.showDialog(this@ZhifuDiscountActivity, "提示", strRet, R.drawable.infoicon)
                        }
                    }

                    PayUtil.TRUE_LOVE_POWDER -> {
                        if (mDialog?.isShowing!!) {
                            mDialog?.cancel()
                        }
                        NineShowApplication.setFirstPayGiftTips(false)
                        Utils.MakeToast("充值成功！已经到账。")
                    }

                    PayUtil.MSG_CHECK_FAILURE -> {
                        if (this@ZhifuDiscountActivity.mDialog!!.isShowing) {
                            this@ZhifuDiscountActivity.mDialog?.cancel()
                        }

                        Utils.MakeToast("充值失败,请检查网络后重试！")
                    }

                    PayUtil.MSG_PAY_THIRD    //充值轮询未查询到
                    -> MyToast.MakeSysToast(NineShowApplication.applicationContext, "确认充值成功后在三十分钟内到账,如未到账请联系客服处理!")
                }
                super.handleMessage(msg)
            } catch (e: Exception) {
                NSLog.e("e", "" + e.message)
            }
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        StatisticsUtil.onEvent(StatisticsEventID.ZHIFU_ETR)
        super.onCreate(savedInstanceState)

        agoMoney = intent.getIntExtra("agoMoney", 0)
        relustMoney = intent.getIntExtra("relustMoney", 0)
        chargeRid = intent.getStringExtra("id")


        payUtil = PayUtil()
        initKuaiFuPay()
        getRoomSystemMessage()

        initView()
        setOnClick()
        StatusBarUtil.setLightMode(this)

    }

    override fun setStatusBar() {
    }

    override fun onResume() {
        isUPPay = false //再次显示时重置状态
        if (!TextUtils.isEmpty(orderId) && mUserBase != null && isNoCallBackPay) {
            isNoCallBackPay = false
            checkOrderThird()
        }
        getUserMoney()
        super.onResume()
    }

    /**
     * 更新系统配置的支付信息
     */
    private fun getRoomSystemMessage() {
        val asyncHttpClient = NSAsyncHttpClient.getInstance()
        val params = NSRequestParams()
        params.put("channel", NineShowApplication.UMENG_CHANNEL)
        asyncHttpClient.get(Constants.NS_ROOM_APPCONF, params, object : NSJsonResponseHandler<RoomSystemMsgResultInfo>() {

            override fun onSuccess(statusCode: Int, rawJsonResponse: String, response: RoomSystemMsgResultInfo?) {
                if (response != null) {
                    if (response.data != null && response.data.priv != null && response.data.priv.size > 0) { //房间系统消息有配置
                        NineShowApplication.setRoomSystemMessageList(response.data.priv)
                    }

                    if (response.data != null && response.data.chatWord != null && response.data.chatWord.size > 0) { //房间系统消息有配置
                        NineShowApplication.setHotWordList(response.data.chatWord)
                    }

                    if (response.data != null && response.data.payType != null) { //支付方式
                        Global.ALIPAY_CHARGE_TYPE = response.data.payType.ali_pay
                        Global.WEIXIN_CHARGE_TYPE = response.data.payType.wx_pay
                    }
                    if (response.data != null && response.data.showwwj == 1) {
                        NineShowApplication.isShowHotGame = true
                    }

                    if (response.data != null && response.data.topUserLevel != null && response.data.topUserLevel.size > 0) { //自定义的等级图标
                        NineShowApplication.setUserCustomLevelList(response.data.topUserLevel)
                    }
                }
            }

            override fun onFailure(statusCode: Int, errorMsg: String) {
            }
        })
    }


    private fun initView() {
        val title = findViewById<TextView>(R.id.title)
        title.text = "折扣卡充值"

        StatusBarUtil.setTranslucentForImageViewInFragment(this, disount_title)
        val lp = right_tv.layoutParams
        lp.width = ViewGroup.LayoutParams.WRAP_CONTENT
        right_tv.layoutParams = lp
        right_tv.text = "账单"
        right_tv.setTextColor(ContextCompat.getColor(this, R.color.red))
        right_tv.setTextSize(TypedValue.COMPLEX_UNIT_SP, 16f)
        right_tv.visibility = View.VISIBLE

        right_tv.setOnClickListener(OnClickListener {
            if (Utils.isLongPeriodNotClickable()) { //是否是快速点击
                return@OnClickListener
            }
            // 跳转广告页
            val intent = Intent(this, AdvertiseActivity::class.java)
            intent.putExtra("url", Constants.LINK_ACCOUNT_LIST_H5)
            intent.putExtra("title", "我的账单")
            intent.putExtra("desc", "我的账单") //
            intent.putExtra("noShare", true) //不可分享
            startActivity(intent)
        })

        disount_tv_rechargeaccount.text = "充值账户：" + mUserBase?.nickname
        disount_tv_rechargeresult.text = (agoMoney * 1000).toString() + "九币"
        disount_tv_agomoney.text = "原价$agoMoney"+"元"
        disount_tv_resultmoney.text = "折后$relustMoney"+"元"

        disount_tv_agomoney.paint.flags = Paint.STRIKE_THRU_TEXT_FLAG //中划线
        disount_tv_agomoney.paint.isAntiAlias = true //去掉锯齿

        pay_checked_1.visibility = View.VISIBLE
        pay_checked_2.visibility = View.GONE
        pay_checked_3.visibility = View.GONE

        var fitstStyle = SpannableStringBuilder()
        fitstStyle.append("支付遇到问题 请联系官方客服 QQ:2541073833")

        //设置点击事件
        val clickableSpan = object : android.text.style.ClickableSpan() {
            override fun onClick(widget: View) {
                Utils.openQQ(  this@ZhifuDiscountActivity, "2541073833")
            }
        }
        fitstStyle.setSpan(clickableSpan, 18, 28, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        disount_tv_fitstrecharge.text = fitstStyle
        //设置字体颜色
        var foregroundColorSpan = ForegroundColorSpan(Color.parseColor("#FF4F4E"))
        fitstStyle.setSpan(foregroundColorSpan, 18, 28, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        disount_tv_fitstrecharge.movementMethod = LinkMovementMethod.getInstance()
        disount_tv_fitstrecharge.text = fitstStyle


        //默认微信选中
        if (Global.WEIXIN_CHARGE_TYPE != 0) {
            chargeType = Global.WEIXIN_CHARGE_TYPE
        } else {
            chargeType = PayUtil.PAY_TYPE_JX_WXPAY
        }
        if (BuildConfig.PAY_MODE == 1) { //百度视频
            chargeType = PayUtil.PAY_TYPE_BD_WXPAY
        }

        disount_btn_buy.text = "确认充值 ¥$relustMoney"
    }

    private fun setOnClick() {
        left_btn.setOnClickListener(this)
        disount_iv_wx.setOnClickListener(this)
        disount_iv_zf.setOnClickListener(this)
        disount_iv_yl.setOnClickListener(this)
        disount_btn_buy.setOnClickListener(this)
    }

    override fun onClick(v: View?) {
        if (Utils.isNotClickable()) {
            return
        }
        when (v?.id) {
            R.id.left_btn -> {
                releaseData()
                this.finish()
            }
            //微信
            R.id.disount_iv_wx -> {
                if (Global.WEIXIN_CHARGE_TYPE != 0) {
                    chargeType = Global.WEIXIN_CHARGE_TYPE
                } else {
                    chargeType = PayUtil.PAY_TYPE_JX_WXPAY
                }
                if (BuildConfig.PAY_MODE == 1) { //百度视频
                    chargeType = PayUtil.PAY_TYPE_BD_WXPAY
                }
                pay_checked_1.visibility = View.VISIBLE
                pay_checked_2.visibility = View.GONE
                pay_checked_3.visibility = View.GONE

            }
            //支付宝
            R.id.disount_iv_zf -> {
                if (Global.ALIPAY_CHARGE_TYPE != 0) {
                    chargeType = Global.ALIPAY_CHARGE_TYPE
                } else {
                    chargeType = PayUtil.PAY_TYPE_JX_ALIPAY
                }

                if (BuildConfig.PAY_MODE == 1) { //百度视频
                    chargeType = PayUtil.PAY_TYPE_BD_ALIPAY
                }
                pay_checked_1.visibility = View.GONE
                pay_checked_2.visibility = View.VISIBLE
                pay_checked_3.visibility = View.GONE
            }
            //银联
            R.id.disount_iv_yl -> {
                if (!Utils.isLongPeriodNotClickable()) {
                    StatisticsUtil.onEvent(StatisticsEventID.ZHIFU_TYPE_YINLIAN)
                    //                    chargeType = 114;
                    chargeType = PayUtil.PAY_TYPE_JX_NEW_UNIPAY
                }
                pay_checked_1.visibility = View.GONE
                pay_checked_2.visibility = View.GONE
                pay_checked_3.visibility = View.VISIBLE
            }
            //支付按钮
            R.id.disount_btn_buy -> {
                //处于家长模式
                if (mUserBase?.family_module == 1) {
                    ParentsModleHintDialog(this@ZhifuDiscountActivity).show()
                    return
                }
                getOrderdate(relustMoney.toString(), chargeType)
            }
        }
    }

    override fun setContentView() {
        setContentView(R.layout.activity_discountcard)
    }

    /**
     * 快付微信支付 初始化webview
     */
    fun initKuaiFuPay() {
        pay_webview = WebView(this@ZhifuDiscountActivity)
        pay_webview?.visibility = View.VISIBLE
        val webSettings = pay_webview?.settings
        webSettings?.javaScriptEnabled = true
        webSettings?.defaultTextEncodingName = "UTF-8"
        // 设置可以访问文件
        webSettings?.allowFileAccess = true
        // 设置支持缩放
        webSettings?.builtInZoomControls = true
        webSettings?.cacheMode = WebSettings.LOAD_NO_CACHE
        // 使用localStorage则必须打开
        webSettings?.domStorageEnabled = true
        webSettings?.setGeolocationEnabled(true)
        pay_webview?.webViewClient = object : WebViewClient() {
            override fun onPageStarted(view: WebView?, url: String?, favicon: Bitmap?) {
                NSLog.i("KuaiFu", "onPageStarted url:$url")
                if (mDialog == null) {
                    mDialog = Utils.showDisountDialog(this@ZhifuDiscountActivity, "正在启动微信...", true)
                    mDialog?.show()
                } else {
                    if (!this@ZhifuDiscountActivity.isFinishing && mDialog != null && !mDialog?.isShowing!!) {
                        mDialog?.show()
                    }
                }
                super.onPageStarted(view, url, favicon)
            }

            override fun onReceivedSslError(view: WebView, handler: SslErrorHandler, error: SslError) {
                //                if(error.getPrimaryError() == android.net.http.SslError.SSL_INVALID ){// 校验过程遇到了bug
                handler.proceed()
                //                }else{
                //                    handler.cancel();
                //                }
            }

            override fun onPageFinished(view: WebView, url: String) {
                super.onPageFinished(view, url)
                if (!this@ZhifuDiscountActivity.isFinishing) {
                    mDialog?.dismiss()
                }
            }

            override fun shouldOverrideUrlLoading(view: WebView?, url: String): Boolean {
                NSLog.i("KuaiFu", "支付 url:$url")
                // 如下方案可在非微信内部WebView的H5页面中调出微信支付
                if (url.startsWith("weixin://wap/pay?") || url.startsWith("alipays://platformapi/startApp?")) {
                    if (!isClikcPayBtn) {
                        return false
                    }
                    isClikcPayBtn = false

                    if (url.startsWith("alipays://platformapi/startApp?")) {
                        if (!checkAliPayInstalled()) { //支付宝未安装
                            isNoCallBackPay = false
                            MyToast.MakeSysToast(NineShowApplication.applicationContext, "支付失败!支付宝未安装!")
                            return true
                        }
                    } else if (url.startsWith("weixin://wap/pay?")) {
                        if (!checkWxInstalled()) { //微信未安装
                            isNoCallBackPay = false
                            MyToast.MakeSysToast(NineShowApplication.applicationContext, "支付失败!微信未安装!")
                            return true
                        }
                    }
                    val intent = Intent()
                    intent.action = Intent.ACTION_VIEW
                    intent.data = Uri.parse(url)
                    startActivity(intent)
                    return true
                } else if (parseScheme(url)) {
                    try {
                        val intent: Intent = Intent.parseUri(url, Intent.URI_INTENT_SCHEME)
                        intent.addCategory("android.intent.category.BROWSABLE")
                        intent.component = null
                        startActivity(intent)
                        return true
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                }
                return false
            }
        }
    }

    private fun kuaiFuWXPay(payinfo: String, realChargeType: Int) {
        isNoCallBackPay = true
        if (pay_webview == null) {
            initKuaiFuPay()
        }
        if (TextUtils.isEmpty(payinfo)) {
            MyToast.MakeToast(this@ZhifuDiscountActivity, "支付参数错误，请重新下单")
        }

        if (realChargeType == PayUtil.PAY_TYPE_YGX_WXPAY) { //云更新微信支付
            val map = HashMap<String, String>()
            map["Referer"] = "https://www.feihuo.com"
            pay_webview?.loadUrl(payinfo, map)
        } else if (realChargeType == PayUtil.PAY_TYPE_BD_WXPAY) { //百度微信支付
            val map = HashMap<String, String>()
            map["Referer"] = "https://v.xiaodutv.com"
            pay_webview?.loadUrl(payinfo, map)
        } else if (realChargeType == PayUtil.PAY_TYPE_JX_WX_KUAIPAY) { //快付
            pay_webview?.loadUrl(payinfo)
        } else {
            pay_webview?.loadUrl(payinfo)
        }
        //dialog.show();
    }

    private fun getUserMoney() {
        if (mUserBase != null) {
            var nineCoin = ""

            if (mUserBase!!.money >= PersonalCenterFragment.TENTHOUSAND && mUserBase!!.money <= PersonalCenterFragment.A_HUNDRED_MILLION) {
                val double1 = (mUserBase?.money?.div((PersonalCenterFragment.TENTHOUSAND * 1.0)))
                nineCoin = double1?.let { Utils.convertToTenThousand(it) }.toString()
            } else if (mUserBase?.money!! > PersonalCenterFragment.A_HUNDRED_MILLION) {
                val double2 = mUserBase?.money?.div((PersonalCenterFragment.A_HUNDRED_MILLION * 1.0))
                nineCoin = double2?.let { Utils.convertToAHundredMillion(it) }.toString()
            } else {
                nineCoin = mUserBase?.money.toString()
            }
            if (TextUtils.isEmpty(mUserBase?.phone)) {
                if (TextUtils.isEmpty(balance) && mUserBase?.isCharge == 0) {
                    balance = nineCoin
                } else if (!TextUtils.isEmpty(balance)) {
                    if (balance != nineCoin) {
                        //展示绑定手机号弹出框
                        Utils.showBindingPhoneDialog(this@ZhifuDiscountActivity, null)
                    }
                }
            }
            disount_tv_balance.text = "九币余额：$nineCoin"
        }
    }

    /**
     * 获取商品订单/签名数据
     *
     * @param input      充值金额
     * @param type 充值方式/类型
     */
    private fun getOrderdate(input: String, type: Int) {
        isClikcPayBtn = true
        mDialog = Utils.showDisountDialog(this@ZhifuDiscountActivity, "请稍候...", true)
        mDialog?.show()
        PayUtil.createOrderDiscountRequest(input, type.toString() + "", mUserBase, chargeRid!!.toInt(),
            applicationContext, object : CreateOrderListener {
                override fun success(result: String?) {
                    if (this@ZhifuDiscountActivity.isFinishing) {
                        return
                    }
                    mDialog?.dismiss()
                    if (result != null) {
                        val jsonObject: JSONObject
                        try {
                            jsonObject = JSONObject(result)
                            val code = jsonObject.optString("code")
                            val msg = jsonObject.optString("message")
                            if ("200" == code) {
                                val jsonObject2 = jsonObject.optJSONObject("data")
                                orderId = jsonObject2.optString("orderid") // 后台生成的订单号
                                var realChargeType = jsonObject2.optInt("type", -1) // 后台生成的订单号
                                if (realChargeType == -1) {
                                    realChargeType = type
                                }

                                NSLog.e("pay type  = $realChargeType")

                                if (realChargeType == PayUtil.PAY_TYPE_JX_ALIPAY) { //支付宝(支付宝官方)
                                    param = jsonObject2.optString("sign")
                                } else {
                                    param = jsonObject2.optString("transid") //签名数据
                                }
                                when (realChargeType) {
                                    PayUtil.PAY_TYPE_JX_UNIPAY // 手机支付 银联
                                    -> if (!isUPPay) {
                                        isUPPay = true
                                        doMobilePay()
                                    }
                                    PayUtil.PAY_TYPE_JX_ALIPAY // 支付宝(官方)
                                    -> aliPayTask()

                                    PayUtil.PAY_TYPE_KF_APP_WXPAY // 快付支付通道app支付
                                        , PayUtil.PAY_TYPE_JX_WXPAY // 微信支付(官方)
                                    -> {
                                        val wxJsonObj = jsonObject2.optJSONObject("params")
                                        doPayWeixinTask(wxJsonObj)
                                    }

                                    PayUtil.PAY_TYPE_YGX_ALIPAY // 云更新支付宝
                                        , PayUtil.PAY_TYPE_YGX_WXPAY //云更新微信支付（微信官方h5）
                                        , PayUtil.PAY_TYPE_JX_WX_KUAIPAY //微信支付（快付）
                                        , PayUtil.PAY_TYPE_BD_WXPAY //百度微信
                                        , PayUtil.PAY_TYPE_BD_ALIPAY //百度支付宝
                                        , PayUtil.PAY_TYPE_JX_WXPAY_H5 //九秀官方h5
                                    -> {
                                        val payinfo = jsonObject2.optString("url")
                                        kuaiFuWXPay(payinfo, realChargeType)
                                    }

                                    PayUtil.PAY_TYPE_JX_NEW_UNIPAY //新银联支付
                                    -> {
                                        val prePayId = jsonObject2.optString("prePayId")
                                        if (!TextUtils.isEmpty(prePayId)) {
                                            UPPayAssistEx.startPay(this@ZhifuDiscountActivity, null, null, prePayId,
                                                PayUtil.UNION_PAY_MODE)
                                        } else {
                                            Utils.MakeToast("第三方生成订单出错,请重试!")
                                        }
                                    }
                                }
                            } else if ("4001" == code) {
                                Utils.MakeToast("第三方生成订单失败")
                            } else if(AccountIdentityDialog.CODE_BIND_PHONE == code || AccountIdentityDialog.CODE_ACCOUNT_IDENTITY == code){  // 绑定手机号/实名认证
                                AccountIdentityDialog.showDialog(this@ZhifuDiscountActivity,code,msg)
                            }else {
                                Utils.MakeToast(msg)
                            }
                        } catch (e: JSONException) {
                            e.printStackTrace()
                        }
                    }
                }

                override fun failure() {
                    if (this@ZhifuDiscountActivity.isFinishing) {
                        return
                    }
                    mDialog?.dismiss()
                    Utils.MakeToast("服务器连接超时，请重试")
                }
            })
    }

    /**
     * 轮询服务器，检查是否支付成功
     */
    private fun checkOrderThird() {
        // 1.显示弹出窗口
        mDialog = Utils.showDisountDialog(this@ZhifuDiscountActivity, "正在查询充值状态……", true)
        mDialog?.show()

        payUtil?.checkOrder(object : OrderRequest {
            override fun checkOrder() {
                PayUtil.checkOrderRequest(orderId, mUserBase,
                    object : PayUtil.PayEndListener {
                        override fun success(firstchargeType: Int, number: Int) {
                            mDialog?.dismiss()
                            checkOrderSuccess(firstchargeType)
                        }

                        override fun failure() {
                            mDialog?.dismiss()
                            mHandler.sendEmptyMessage(PayUtil.MSG_PAY_THIRD)
                        }
                    })
            }

            override fun failure() {
                mDialog?.dismiss()
                mHandler.sendEmptyMessage(PayUtil.MSG_PAY_THIRD)
            }
        }, PayUtil.PERIOD_THIRE, 1000, PayUtil.MSG_MOBILE_CARD_FAILURE, mHandler)
    }

    private fun checkOrderSuccess(firstchargeType: Int) {
        Log.e("checkCount:  ", "checkOrderSuccess--")
        val msg = mHandler.obtainMessage()
        msg.what = PayUtil.TRUE_LOVE_POWDER
        msg.arg1 = firstchargeType
        mHandler.sendMessage(msg)
        AppBroadcastHelper.getInstance().sendBroadcast(NSReceiverAction.ACTION_REFRESH)
        var dislog = object: DiscountSuccessDialog(this@ZhifuDiscountActivity){
            override fun doConfirm() {
                this@ZhifuDiscountActivity.finish()
            }
        }
        dislog.show()
        notifyUserInfo()
        payUtil?.stopCheck()
    }

    protected fun notifyUserInfo() {
        PayUtil.notifyUserInfoRequest(mUserBase, object : NotifyUserInfoListener {
            override fun success(result: String?) {
                if (result != null) {
                    val jsonObject: JSONObject
                    try {
                        jsonObject = JSONObject(result)
                        val code = jsonObject.optString("code")
                        if ("200" == code) {
                            val data = jsonObject.optJSONObject("data")
                            mUserBase!!.money = data
                                .optInt("money").toLong()
                            mUserBase!!.tokencoin = data
                                .optInt("tokencoin").toLong()
                            mUserBase!!.wealthlevel = data
                                .optInt("wealthlevel")
                            NineShowApplication.getManager().notifyState() //若从个人中心跳转过来的 则更改个人中心的 金额显示
                            getUserMoney() //刷新余额
                        }
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                }
            }

            override fun failure() {
                Utils.MakeToast("更新金币信息失败！ 请重新登录")
            }
        })
    }

    private fun doPayWeixinTask(param: JSONObject) {
        val appid = param.optString("appid")
        if (TextUtils.isEmpty(appid)) {
            mWXPayCallBack.onError(WXPay.ERROR_PAY_PARAM)
            return
        }
        WXPay.init(this, appid)
        val manager = this.getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
        val networkinfo = manager.activeNetworkInfo
        if (networkinfo != null && networkinfo.isConnected) {
            WXPay.getInstance().doPay(param, mWXPayCallBack)
        } else { //若无网，则应用原来逻辑
            val builder = AlertDialog.Builder(this, R.style.CustomBgTransparentDialog)
            builder.setIcon(R.drawable.logo)
            builder.setTitle("网络状态")
            builder.setMessage("没有可用网络,是否进入设置面板")
            builder.setPositiveButton("是"
            ) { dialog, which ->
                startActivity(Intent(
                    android.provider.Settings.ACTION_WIRELESS_SETTINGS))
            }
            builder.setNegativeButton("否",
                object : DialogInterface.OnClickListener {
                    override fun onClick(dialog: DialogInterface, which: Int) {
                        MyToast.makeToastCenter(this@ZhifuDiscountActivity, "联网失败")
                    }
                })
            builder.create().show()
        }
    }

    /*
     * 调用支付宝支付(支付宝官方)
     */
    private fun aliPayTask() {
        val payRunnable = Runnable {
            // 构造PayTask 对象
            val alipay = PayTask(this@ZhifuDiscountActivity)
            // 调用支付接口，获取支付结果
            val result = alipay.pay(param)

            val msg = Message()
            msg.what = PayUtil.MSG_ZHIFUBAO
            msg.obj = result
            mHandler.sendMessage(msg)
        }
        // 必须异步调用
        val payThread = Thread(payRunnable)
        payThread.start()
    }

    /**
     * 调用银联支付
     */
    protected fun doMobilePay() {
        UPPayAssistEx.startPayByJAR(this@ZhifuDiscountActivity, PayActivity::class.java, null, null, param,
            PayUtil.UNION_PAY_MODE)
    }

    /**
     * 银联回调
     */
    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        if (data == null) {
            return
        }
        if (chargeType == 163) { // 银联手机支付
            val temp = StringBuilder()
            val str = data.extras?.getString("pay_result")
            if ("success".equals(str, ignoreCase = true)) { //str 放后面括号内 避免空指针异常
                // 一键注册充值，强制进行更改帐号密码
                //                if (NineShowApplication.mUserBase != null && NineShowApplication.isUseOnekeyReister() && !NineShowApplication.isChangeOnekeyReisterPwd()) {
                //                    if (boundDialogUtils == null) {
                //                        boundDialogUtils = new BoundDialogUtils();
                //                    }
                //                    boundDialogUtils.showOneKeyChangePwdDialog(ZhifuActivity.this);
                //                }
                NineShowApplication.setCharged(true)
                checkOrder()
                return
            } else if ("fail".equals(str, ignoreCase = true)) {
                temp.append("支付失败!")
            } else if ("cancel".equals(str, ignoreCase = true)) {
                temp.append("用户取消了支付")
            }

            val builder = AlertDialog.Builder(this)
            builder.setTitle("支付结果通知")
            builder.setMessage(temp.toString())
            builder.setInverseBackgroundForced(true)
            builder.setNegativeButton("确定") { dialog, which -> dialog.dismiss() }
            builder.create().show()
        }
    }

    fun parseScheme(url: String): Boolean {
        return if (url.contains("platformapi/startapp")) {
            true
        } else Build.VERSION.SDK_INT > Build.VERSION_CODES.M && url.contains("platformapi") && url.contains("startapp")
    }

    /**
     * 轮询服务器，检查是否支付成功
     */
    private fun checkOrder() {
        // 1.显示弹出窗口
        mDialog = Utils.showDisountDialog(this@ZhifuDiscountActivity, "正在充值……", true)
        mDialog?.show()
        
        payUtil?.checkOrder(object : OrderRequest {
            override fun checkOrder() {
                PayUtil.checkOrderRequest(orderId, mUserBase,
                    object : PayUtil.PayEndListener {
                        override fun success(firstchargeType: Int, number: Int) {
                            mDialog?.dismiss()
                            checkOrderSuccess(firstchargeType)
                        }

                        override fun failure() {
                            mDialog?.dismiss()
                            mHandler.sendEmptyMessage(PayUtil.MSG_CHECK_FAILURE)
                        }
                    })
            }

            override fun failure() {
                mDialog?.dismiss()
                mHandler.sendEmptyMessage(PayUtil.MSG_CHECK_FAILURE)
            }
        }, PayUtil.PERIOD_ZHIFUBAO, 1000, PayUtil.COUNT, mHandler)
    }

    /**
     * 检测支付宝是否已安装
     *
     * @return
     */
    fun checkAliPayInstalled(): Boolean {
        val uri = Uri.parse("alipays://platformapi/startApp")
        val intent = Intent(Intent.ACTION_VIEW, uri)
        val componentName = intent.resolveActivity(NineShowApplication.applicationContext.packageManager)
        return componentName != null
    }

    /**
     * 检测微信是否安装
     *
     * @return
     */
    fun checkWxInstalled(): Boolean {
        val uri = Uri.parse("weixin://wap/pay?")
        val intent = Intent(Intent.ACTION_VIEW, uri)
        val componentName = intent.resolveActivity(NineShowApplication.applicationContext.packageManager)
        return componentName != null
    }

    override fun onBackPressed() {
        releaseData()
        super.onBackPressed()
    }

    override fun getActStatisticsTag(): String {
        return this.javaClass.simpleName
    }

    private fun releaseData() {
        mHandler.removeCallbacksAndMessages(null)
    }

    /**
     * 微信官方回调
     */
    private val mWXPayCallBack = object : WXPay.WXPayResultCallBack {
        override fun onSuccess() {
            // 一键注册充值，强制进行更改帐号密码
            //			if (NineShowApplication.mUserBase != null && NineShowApplication.isUseOnekeyReister() && !NineShowApplication.isChangeOnekeyReisterPwd()) {
            //				if(boundDialogUtils ==null){
            //					boundDialogUtils = new BoundDialogUtils();
            //				}
            //				boundDialogUtils.showOneKeyChangePwdDialog(ZhifuActivity.this);
            //			}
            NineShowApplication.setCharged(true)
            checkOrder()
        }

        override fun onError(error_code: Int) {
            when (error_code) {
                WXPay.NO_OR_LOW_WX -> MyToast.MakeToast(this@ZhifuDiscountActivity, "未安装微信或微信版本过低")

                WXPay.ERROR_PAY_PARAM -> MyToast.MakeToast(this@ZhifuDiscountActivity, "参数错误")

                WXPay.ERROR_PAY -> MyToast.MakeToast(this@ZhifuDiscountActivity, "支付失败")
            }
        }

        override fun onCancel() {
            MyToast.MakeToast(this@ZhifuDiscountActivity, "支付取消")
        }
    }
}
