package com.ninexiu.sixninexiu.adapter

import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.fragment.app.FragmentStatePagerAdapter

/**
 *
 * @CreateDate: 2020/8/27 18:39
 * @Author:     wagnyu
 * @Description:
 * @Version:    1.0
 */
class DressUpViewPageAdapter(fm: FragmentManager, private val mFragments: List<Fragment>) : FragmentStatePagerAdapter(fm) {

    private var mTitile = arrayOf("徽章", "头像框")

    override fun getCount(): Int {
        return mTitile.size
    }

    override fun getPageTitle(position: Int): CharSequence? {
        return mTitile[position]
    }

    override fun getItem(position: Int): Fragment {
        return mFragments[position]
    }

    public fun setTitle(title:Array<String>){
        mTitile = title
    }

}