package com.ninexiu.sixninexiu.adapter.store

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.IconList
import com.ninexiu.sixninexiu.common.util.GlideUtils
import kotlinx.android.synthetic.main.item_guard_buy_privilege.view.*
import java.util.ArrayList

/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/08/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class GuardBuyPrivilegeAdapter(val context: Context, val guardPrivileges: ArrayList<IconList>) : RecyclerView.Adapter<GuardBuyPrivilegeAdapter.GuardBuyPrivilegeHolder>() {


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): GuardBuyPrivilegeHolder {
        return GuardBuyPrivilegeHolder(LayoutInflater.from(context).inflate(R.layout.item_guard_buy_privilege, parent, false))
    }

    override fun getItemCount(): Int {
        return guardPrivileges.size
    }

    override fun onBindViewHolder(holder: GuardBuyPrivilegeHolder, position: Int) {
        GlideUtils.loadCirclePic(context, guardPrivileges[position].img_url, holder.view.privilege_iv)
        holder.view.privilege_tv.text = guardPrivileges[position].name
    }


    class GuardBuyPrivilegeHolder(val view: View) : RecyclerView.ViewHolder(view)

}