package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/24
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class DressUpTabBean(
    val code: Int,
    val `data`: List<DressUpTab>,
    val message: String
)

data class DressUpTab(
    val id: Int,
    val name: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(id)
        parcel.writeString(name)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<DressUpTab> {
        override fun createFromParcel(parcel: Parcel): DressUpTab {
            return DressUpTab(parcel)
        }

        override fun newArray(size: Int): Array<DressUpTab?> {
            return arrayOfNulls(size)
        }
    }
}