package com.ninexiu.sixninexiu.bean

import com.google.gson.GsonBuilder
import com.google.gson.JsonSyntaxException
import java.lang.Exception

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/05/27
 *     desc   : 新的礼物面板数据 -> tab 做成了动态的
 *     version: 1.0
 * </pre>
 */
data class GiftInfoResultNew(
        val code : Int,
        val message : String? = null,
        val data : GiftInfoData? = null,
) {
    companion object {
        fun objectFromData(jsonData: String) : GiftInfoResultNew?{
            val gson = GsonBuilder().create()
            var info : GiftInfoResultNew? = null
            try {
                info = gson.fromJson(jsonData,GiftInfoResultNew::class.java)
            }catch (e : JsonSyntaxException) {
            }
            return info
        }
    }
}

data class GiftInfoData(
        val tabNameList : List<String>? = null,
        val giftList : List<List<GiftInfo?>?>? = null
)