package com.ninexiu.sixninexiu.bean

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/06/17
 *     desc   : 礼物面板对应的周星礼物 --> 冠名主播 & 冠名用户
 *     version: 1.0
 * </pre>
 */
data class GiftWeekResult(
        val code : Int,
        val message : String? = null,
        val data : List<GiftWeekItem>? = null
)

// 通过礼物id来匹配冠名主播和冠名用户数据
data class GiftWeekItem(
        val gid : String? = null,
        val anchoruid : String? = null,
        val anchornick : String? = null,
        val userid : String? = null,
        val usernick : String? = null,
)