package com.ninexiu.sixninexiu.bean

import com.chad.library.adapter.base.entity.MultiItemEntity

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/02
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class HomeInfo : MultiItemEntity {
    companion object {
        // 标题
        const val TYPE_TITLE = 0

        // 精选推荐
        const val TYPE_EXCEL_RECOMMEND = 1

        // 推荐,新人,热门
        const val TYPE_ANCHOR = 2

        // 标签
        const val TYPE_LABEL = 3

        // banner
        const val TYPE_BANNER = 4

        // 以下是细分,主要是为了adapter中的一些特殊处理
        const val TYPE_RECOMMEND = 5
        const val TYPE_NEW = 6
        const val TYPE_HOT = 7
    }

    // 为了adapter中的一些特殊处理(买点&针对不同分类模块做的处理)
    var dealWithType = -1

    var index = 0  // 为了控制item左右间距

    var anchorInfo: AnchorInfo? = null

    fun addAnchorInfoByIndex(anchorInfo: AnchorInfo?,index : Int){
        this.anchorInfo = anchorInfo
        this.index = index
    }

    // 精选推荐(单独使用,因为要设置背景)
    var anchorExcelRecommend : List<AnchorInfo>? = null

    // 标签
    var labelInfo: List<HomeTagInfo.DataBean>? = null

    // banner
    var bannerInfo: List<AdvertiseInfo>? = null

    // 标题
    var titleInfo: HomeTitleInfo? = null

    var currentType = TYPE_TITLE

    override fun getItemType() = currentType
}