package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class PropsAllBean(
        val code: Int,
        val `data`: PropsListBean,
        val message: String
)

data class PropsListBean(
        val `data`: List<PropsList>,
)

data class PropsList(
        val list: List<Props>?,
        val title: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.createTypedArrayList(Props),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeTypedList(list)
        parcel.writeString(title)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<PropsList> {
        override fun createFromParcel(parcel: Parcel): PropsList {
            return PropsList(parcel)
        }

        override fun newArray(size: Int): Array<PropsList?> {
            return arrayOfNulls(size)
        }
    }
}


data class Props(
        val background: String?,
        val category: Int,
        val deadLine: String?,
        val endtime: String?,
        val gid: String?,
        val giftname: String?,
        val id: String?,
        val imgurl: String?,
        val is_fast_expiration: Int,
        var isactive: Int,
        val name: String?,
        val num: Int,
        val price: String?,
        val priceInfo: List<BuyTimeList>?,
        val profit: String?,
        val rid: String?,
        val starttime: String?,
        val status: Int,
        val stocktype: Int=0,
        val typeTag: Int,
        val uid: String?,
        val tips:String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readString(),
            parcel.createTypedArrayList(BuyTimeList),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readInt(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(background)
        parcel.writeInt(category)
        parcel.writeString(deadLine)
        parcel.writeString(endtime)
        parcel.writeString(gid)
        parcel.writeString(giftname)
        parcel.writeString(id)
        parcel.writeString(imgurl)
        parcel.writeInt(is_fast_expiration)
        parcel.writeInt(isactive)
        parcel.writeString(name)
        parcel.writeInt(num)
        parcel.writeString(price)
        parcel.writeTypedList(priceInfo)
        parcel.writeString(profit)
        parcel.writeString(rid)
        parcel.writeString(starttime)
        parcel.writeInt(status)
        parcel.writeInt(stocktype)
        parcel.writeInt(typeTag)
        parcel.writeString(uid)
        parcel.writeString(tips)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<Props> {
        override fun createFromParcel(parcel: Parcel): Props {
            return Props(parcel)
        }

        override fun newArray(size: Int): Array<Props?> {
            return arrayOfNulls(size)
        }
    }

}
