package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/30
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class StorePropsBean(
    val code: Int,
    val `data`: List<StoreProps>,
    val message: String
)

data class StoreProps(
    val tips: String?,
    val name: String?,
    val priceInfo: List<BuyTimeList>?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readString(),
            parcel.createTypedArrayList(BuyTimeList)) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(tips)
        parcel.writeString(name)
        parcel.writeTypedList(priceInfo)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<StoreProps> {
        override fun createFromParcel(parcel: Parcel): StoreProps {
            return StoreProps(parcel)
        }

        override fun newArray(size: Int): Array<StoreProps?> {
            return arrayOfNulls(size)
        }
    }
}