package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/7/13
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class TopicTabListBean(
    val code: Int,
    val `data`: List<TopicTab>,
    val message: String
)

data class TopicTab(
    val tab_id: Int,
    val tab_name: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(tab_id)
        parcel.writeString(tab_name)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<TopicTab> {
        override fun createFromParcel(parcel: Parcel): TopicTab {
            return TopicTab(parcel)
        }

        override fun newArray(size: Int): Array<TopicTab?> {
            return arrayOfNulls(size)
        }
    }
}