package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable
import java.io.Serializable

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/7/13
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class TopicTopListBean(
        val code: Int,
        val `data`: List<Topic>?,
        val message: String
)

data class Topic(
        var topicid: Int = 0,
        val is_activity: Int = 0,
        val name: String? = null,
        var title: String? = null,
        val url: String? = null,
        val tab_id: Int = 0,
        val id: String? = null,
        val ac_title: String? = null,
        val ac_url: String? = null,
        val introduce: String? = null,
        var isfollow: Int=0,
        val total: Int=0,
        val type:Int=0
) : Parcelable,Serializable {

    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readInt(),
            parcel.readInt()) {
    }

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other !is Topic) return false
        if (title != other.title) return false

        return true
    }

    override fun hashCode(): Int {
        return title?.hashCode() ?: 0
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(topicid)
        parcel.writeInt(is_activity)
        parcel.writeString(name)
        parcel.writeString(title)
        parcel.writeString(url)
        parcel.writeInt(tab_id)
        parcel.writeString(id)
        parcel.writeString(ac_title)
        parcel.writeString(ac_url)
        parcel.writeString(introduce)
        parcel.writeInt(isfollow)
        parcel.writeInt(total)
        parcel.writeInt(type)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<Topic> {
        override fun createFromParcel(parcel: Parcel): Topic {
            return Topic(parcel)
        }

        override fun newArray(size: Int): Array<Topic?> {
            return arrayOfNulls(size)
        }
    }


}


data class TopicInfoBean(
        val code: Int,
        val `data`: TopicInfo?,
        val message: String
)

data class TopicInfo(
        val id: String?,
        val title: String?,
        val introduce: String?,
        val cover_url: String?,
        val tab: Int,
        val ac_title: String?,
        val ac_url: String?,
        val is_activity: Int,
        val addtm: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(id)
        parcel.writeString(title)
        parcel.writeString(introduce)
        parcel.writeString(cover_url)
        parcel.writeInt(tab)
        parcel.writeString(ac_title)
        parcel.writeString(ac_url)
        parcel.writeInt(is_activity)
        parcel.writeString(addtm)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<TopicInfo> {
        override fun createFromParcel(parcel: Parcel): TopicInfo {
            return TopicInfo(parcel)
        }

        override fun newArray(size: Int): Array<TopicInfo?> {
            return arrayOfNulls(size)
        }
    }

}