package com.ninexiu.sixninexiu.bean

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/11/26
 *     desc   : 用户回归充值福利数据类
 *     version: 1.0
 * </pre>
 */
data class UserReturnPayResult(
    val data : UserReturnPayData? = null
): BaseResultInfo()

data class UserReturnPayData(
        val over_time : Long,
        val list : MutableList<UserReturnPayItem>? = null,
        val money : Int
)

data class UserReturnPayItem(
        val id : Int,
        val name : String?,
        val gid : Long,
        val count : Int,
        val money : Int,
        val explain : String?,
        val form : String?,
        val img : String?,
        var status : Int
)