package com.ninexiu.sixninexiu.block

import android.os.Looper

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/01/30
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class BlockDetectByPrinter {
    companion object {
        const val start = ">>>>> Dispatching"
        const val end = "<<<<< Finished"
    }

    fun start() {
        Looper.getMainLooper().setMessageLogging {log ->
            if(log.startsWith(prefix = start)) {
                LogMonitor.getInstance().startMonitor()
            }

            if(log.startsWith(prefix = end)) {
                LogMonitor.getInstance().removeMonitor()
            }
        }
    }
}