package com.ninexiu.sixninexiu.block

import android.content.Context
import android.graphics.Canvas
import android.util.AttributeSet
import android.widget.TextView
import androidx.appcompat.widget.AppCompatTextView
import com.ninexiu.sixninexiu.common.util.NSLog

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/01/30
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class MonitorTextView  @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : TextView(context, attrs, defStyleAttr) {
    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        if (text.contains("imgface")) {
            NSLog.d("addSmileySpans1 >> start : ", "" + System.currentTimeMillis())
        }
        super.onMeasure(widthMeasureSpec, heightMeasureSpec)
    }

    override fun onDraw(canvas: Canvas?) {
        super.onDraw(canvas)
        if (text.contains("imgface")) {
            NSLog.d("addSmileySpans1 >> end : ", "" + System.currentTimeMillis())
        }
    }
}