package com.ninexiu.sixninexiu.common.util

import android.os.Bundle
import com.ninexiu.sixninexiu.broadcast.AppBroadcastHelper
import com.ninexiu.sixninexiu.broadcast.NSDataBroadcast

/**
 * @author: lou
 * @date: 2021/8/27
 * desc:通用的广播，跳转业务
 */
//发送关闭直播间广播
fun sendCloseLiveRoomBroadCastReceiver(isToast:Boolean){
    //先发送广播  关闭流
    if (isToast) {
        val bundle = Bundle()
        bundle.putInt("status", 1)
        AppBroadcastHelper.getInstance().sendBroadcast(
                NSReceiverAction.ACTION_GOTOCLOSE_LIVEROOM,
                NSDataBroadcast.TYPE_OPERATION_DEFAULT,
                bundle
        )
    }
}