package com.ninexiu.sixninexiu.common.util.manager

import android.content.Context
import android.view.View
import android.widget.ImageView
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.view.RoundCornerImageView
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.setVisible

/**
 * @author: lou
 * @date: 2021/9/14
 * desc:
 */
class TrueLoveGroupProgressManager {

    var pCoverIv: ImageView? = null


    fun initProgress(context: Context, view: View, progress: Float) {
        val constraintLayout = view.findViewById<ConstraintLayout>(R.id.progress_layout)

        val heartImage = view.findViewById<ImageView>(R.id.img_true_love_group_heart)
                heartImage.setOnClickListener {
                    heartImage.setVisible(false)
                    constraintLayout.setVisible(true)
                    pCoverIv = view.findViewById<RoundCornerImageView>(R.id.p_cover_iv)

                }

        constraintLayout.setOnClickListener{
            heartImage.setVisible(true)
            constraintLayout.setVisible(false)
        }

        if (constraintLayout.visibility == View.VISIBLE){
            setProgress(progress,context)
        }



    }

    fun setProgress(percent: Float, context: Context) {


        val percentFloat: Float = percent / 100.0f
        var marginEnd = percentFloat * dp2px(context, 120)
        if (marginEnd == 0f) {
            marginEnd = 1f
        }
        val lp = pCoverIv?.layoutParams as ConstraintLayout.LayoutParams
        lp.apply {
            height = marginEnd.toInt()
        }
        pCoverIv?.postInvalidate()
    }


}