package com.ninexiu.sixninexiu.view

import android.text.TextPaint
import android.text.style.ClickableSpan
import android.view.View

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/04
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class ClickSpanImpl(val onClick: (() -> Unit)? = null) : ClickableSpan() {
    override fun onClick(widget: View) {
        onClick?.invoke()
    }

    override fun updateDrawState(ds: TextPaint) {
        super.updateDrawState(ds)
        ds.isUnderlineText = false
    }

}