package com.ninexiu.sixninexiu.view

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.widget.ImageView
import com.ninexiu.sixninexiu.R

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/07/06
 *     desc   : 个人主页item
 *     version: 1.0
 * </pre>
 */
@SuppressLint("Recycle")
class PersonCenterToggleImageView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ImageView(context, attrs, defStyleAttr) {
    var currentStatus = false // 开关当前的状态,初始化false
    fun setGiftStatus(status: Boolean) {
        currentStatus = status
        setImageResource(if (status) R.drawable.ic_toggle_selected else R.drawable.ic_toggle_unselected)
    }

}