package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.*
import kotlinx.android.synthetic.main.dialog_autumn_charge.*
import kotlinx.android.synthetic.main.dialog_autumn_charge_success.*
import kotlinx.android.synthetic.main.dialog_autumn_charge_success.dialogContainer

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/08/06
 *     desc   : 金秋礼包确认
 *     version: 1.0
 * </pre>
 */
class AutumnSuccessDialog(context: Context,var giftUrl : String) : BaseDialog(context) {
    companion object {
    }

    override fun getContentView() = R.layout.dialog_autumn_charge_success

    override fun initDatas() {
        super.initDatas()

    }

    override fun initView() {
        super.initView()
        GlideUtils.loadNormalImg(context, giftUrl, ivSuccessGift)
        ivSuccessConfirm.setOnClickListener { dismiss() }


        val widthScreen = getScreenWidth(context)

        dialogContainer.post {
            fitterViewSize(dialogContainer,{ (0.8373 * widthScreen).toInt() }, { (1.43 * it).toInt() })
            fitterViewSize(ivSuccessGift,{ (0.797 * widthScreen).toInt() }, { (0.803 * it).toInt() })
            fitterViewPosition(ivSuccessGift, ORIENTATION_TOP, { (0.296 * widthScreen).toInt() })
            fitterViewPosition(ivSuccessConfirm, ORIENTATION_BOTTOM, { (0.0373 * widthScreen).toInt() })
        }
    }
}