package com.ninexiu.sixninexiu.view.dialog

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Handler
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.PopupWindow
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.ConfigSpHelper
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.TimeUtil
import com.ninexiu.sixninexiu.view.UserReturnGsonHelper
import com.ninexiu.sixninexiu.view.popwindow.BasePopupWindow

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/05/17
 *     desc   : 直播间关闭
 *     version: 1.0
 * </pre>
 */
class CupidRulePopWindow(context: Context) : PopupWindow(context) {

    @SuppressLint("InflateParams")
    var view : View = LayoutInflater.from(context).inflate(R.layout.layout_cupid_rule,null,false)

    init {
        contentView = view

        this.width = ViewGroup.LayoutParams.WRAP_CONTENT
        this.height = ViewGroup.LayoutParams.WRAP_CONTENT
        this.isFocusable = true
        val dw = ColorDrawable(Color.TRANSPARENT)
        setBackgroundDrawable(dw)
    }
}