package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.text.Editable
import android.text.TextWatcher
import android.view.Gravity
import android.view.View
import android.view.View.OnLongClickListener
import android.view.Window
import androidx.core.content.ContextCompat
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.*
import com.ninexiu.sixninexiu.common.util.manager.RequestManager
import com.tencent.qcloud.tim.uikit.PushContants

/**
 * <pre>
 *     @author : wangyu
 *     time   : 2021/04/19
 *     desc   : 关注自动回复，语音设置弹窗
 * </pre>
 */
class FollowHelloVoiceSettingDialog(context: Context, var type :Int,var operation: Int) : BaseDialog(context), View.OnClickListener{

    companion object{
        fun create(context: Context?,type :Int,operation:Int): FollowHelloVoiceSettingDialog? {
            return context?.let { FollowHelloVoiceSettingDialog(it,type,operation) }
        }
    }

    override fun getContentView() = R.layout.dialog_follow_hello_voice_setting

    override fun initView() {
        super.initView()

    }

    override fun initDatas() {
        super.initDatas()
    }

    override fun initEvents() {
        super.initEvents()


    }

    override fun getWindows(window: Window?) {
        super.getWindows(window)
        if (window != null && PushContants.ISINLIVEROOM) {
            window.setGravity(Gravity.BOTTOM)
        }
    }

    override fun onClick(v: View?) {
        if (Utils.isNotClickable())
            when (v?.id) {
                R.id.tv_text_setting_save->{
//                    RequestManager.create().setCustomGteet(type,et_text_setting.text.toString().trim(),operation)
                }
            }
    }

}