package com.ninexiu.sixninexiu.adapter

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.AdviseAnchorInfo
import com.ninexiu.sixninexiu.bean.AnchorDialogListInfo
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.common.util.Utils

/**
 * @author: lou
 * @date: 2021/8/27
 */
class AnchorDialogAdapter(data:List<AdviseAnchorInfo>):
    BaseQuickAdapter<AdviseAnchorInfo, AnchorDialogAdapter.ViewHolder>(R.layout.adapter_anchor_dialog,data) {



    override fun convert(holder: AnchorDialogAdapter.ViewHolder?, data: AdviseAnchorInfo?) {

        GlideUtils.loadNormalPic(mContext,data?.phonehallposter,holder?.icon)
        holder?.anchor_count?.text =  data?.usercount.toString()
        holder?.anchor_name?.text = data?.nickname


    }

    class ViewHolder(view: View):BaseViewHolder(view) {
        var icon: ImageView = view.findViewById(R.id.icon)
        val anchor_count: TextView = view.findViewById(R.id.anchor_count)
        val anchor_name: TextView = view.findViewById(R.id.anchor_name)
    }
}