package com.ninexiu.sixninexiu.adapter

import android.view.View
import android.widget.ImageView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.LabelBean
import com.ninexiu.sixninexiu.common.util.GlideUtils
import com.ninexiu.sixninexiu.view.setVisible

/**
 * @author: lou
 * @date: 2021/8/30
 * desc:新增的个人资料相册集合适配器
 */
class NewPersonDynamicAdapter(data:MutableList<LabelBean>):BaseQuickAdapter<LabelBean,NewPersonDynamicAdapter.ViewHolder>(
    R.layout.item_personal_dialog_album,data) {
    class ViewHolder(view: View):BaseViewHolder(view) {
        val img_personal_item_icon = view.findViewById<ImageView>(R.id.img_personal_item_icon)
        val play_icon = view.findViewById<ImageView>(R.id.play_icon)


    }

    override fun convert(p0: ViewHolder?, p1: LabelBean?) {
        GlideUtils.loadNormalPic(mContext,p1?.imageurl,p0?.img_personal_item_icon)
        if (p1?.isvideo == 1) {
            p0?.play_icon.setVisible(true)
        }
    }
}