package com.ninexiu.sixninexiu.audio

import java.io.File

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/03/19
 *     desc   :
 *     version: 1.0
 * </pre>
 */
interface OnAudioRecordListener {
    // 录音初始化失败
    fun onAudioInitFailed(msg: String)

    // 录音开始
    fun onAudioRecordStart()

    // 录音过程回调
    fun onAudioProgress(duration: Int)

    // 录音结束
    fun onAudioFinish(effective: Boolean, audioFilePath: String?, duration: Int)     // effective : 是否有效    audioFile : 录音文件  duration : 录音时长

    /*// 录音试听开始
    fun onAudioPlayStart()

    // 录音开始倒计时
    fun onAudoPlayCutDown(duration: Int)

    // 录音试听结束
    fun onAudioPlayEnd(isError: Boolean)*/
}