package com.ninexiu.sixninexiu.bean

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/08/30
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class AccountLockResult(
        val code: Int,
        val message: String?,
        val data: AccountLockData? = null
)

data class AccountLockData(
        val info: List<AccountLockItem>? = null,     // 看过我条目
        val imgArr: List<String>? = null,           // 看过我头像
        val lookedCount: Int = 0,                   //次数
        val desc:String? = null,
        val lookedUserCount:Int = 0                      //看过我人数
)

data class AccountLockItem(
        val name: String? = null,
        val lock: Int = 0
)