package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

data class AuctionAddressBean(
        val code: Int,
        val `data`: AuctionAddressData,
        val message: String
)

data class AuctionAddressData(
        val province: String?,
        val city: String?,
        val county: String?,
        val detail: String?,
        val nickname: String?,
        val phone: String?,
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(province)
        parcel.writeString(city)
        parcel.writeString(county)
        parcel.writeString(detail)
        parcel.writeString(nickname)
        parcel.writeString(phone)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<AuctionAddressData> {
        override fun createFromParcel(parcel: Parcel): AuctionAddressData {
            return AuctionAddressData(parcel)
        }

        override fun newArray(size: Int): Array<AuctionAddressData?> {
            return arrayOfNulls(size)
        }
    }
}