package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

data class AuctionOrderBean(
        val code: Int,
        val `data`: AuctionOrderData,
        val message: String
)

data class AuctionOrderData(
        val amount: String?,
        val count: Int = 0,
        val express_price: String?,
        val goods_name: String?,
        val img1: String?,
        val order_id: String?,
        val sell_type: String?,
        val status: String?,
        val total_price: String?,
        var address: String?,
        var addressee: String?,
        var province: String?,
        var city: String?,
        var county: String?,
        var detail: String?,
        val down_time: Long = 0L,
        val fixed_price: String?,
        val refund_price: String?,
        val imgs: List<String>?,
        var phone: String?,
        val total_coin: Float = 0f,
        val leave_message: String?,
        val order_time: String?,
        val pay_time: String?,
        val refund_time: String?,
        val cancel_time: String?,
        val pay_type: String?,
        val express_order: String?,
        val is_show_money: Int,
        val refund_coin: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readLong(),
            parcel.readString(),
            parcel.readString(),
            parcel.createStringArrayList(),
            parcel.readString(),
            parcel.readFloat(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readString()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(amount)
        parcel.writeInt(count)
        parcel.writeString(express_price)
        parcel.writeString(goods_name)
        parcel.writeString(img1)
        parcel.writeString(order_id)
        parcel.writeString(sell_type)
        parcel.writeString(status)
        parcel.writeString(total_price)
        parcel.writeString(address)
        parcel.writeString(addressee)
        parcel.writeString(province)
        parcel.writeString(city)
        parcel.writeString(county)
        parcel.writeString(detail)
        parcel.writeLong(down_time)
        parcel.writeString(fixed_price)
        parcel.writeString(refund_price)
        parcel.writeStringList(imgs)
        parcel.writeString(phone)
        parcel.writeFloat(total_coin)
        parcel.writeString(leave_message)
        parcel.writeString(order_time)
        parcel.writeString(pay_time)
        parcel.writeString(refund_time)
        parcel.writeString(cancel_time)
        parcel.writeString(pay_type)
        parcel.writeString(express_order)
        parcel.writeInt(is_show_money)
        parcel.writeString(refund_coin)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<AuctionOrderData> {
        override fun createFromParcel(parcel: Parcel): AuctionOrderData {
            return AuctionOrderData(parcel)
        }

        override fun newArray(size: Int): Array<AuctionOrderData?> {
            return arrayOfNulls(size)
        }
    }

    constructor(order_id: String?) : this("", 0, "", "", "", order_id, "", "", "", "", "", "", "", "", "", 0L, "", "", null, "", 0f, "", "", "", "", "", "", "", 0, "")
}