package com.ninexiu.sixninexiu.bean

import android.os.Parcel
import android.os.Parcelable

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/8/24
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class DressUpGoodsListBean(
        val code: Int,
        val `data`: List<DressUpGoods>,
        val message: String
)

data class DressUpGoods(
        val addtime: String?,
        val credit_level: String?,
        val day: String?,
        val desc: String?,
        val end_time: String?,
        val equalname: String?,
        val explain: String?,
        val frame_id: String?,
        var id: String?,
        val gid: String?,
        val is_new_status: Int,//上新
        val link: String?,
        val name: String?,
        val price: String?,
        val ratio: String?,
        val sort: String?,
        val source: String?,
        val start_time: String?,
        val status: String?,
        val type: Int,
        val state: Int,
        val url: String?,
        val usertype: String?,
        val wealth_level: String?,
        val labelstr: String?,
        val background: String?,
        val is_fast_expiration: Int,//是否即将到期
        var isactive: Int,//穿戴的状态
        val deadLine: String?,//到期时间
        val surplus: String?,//到期时间
        val imgurl: String?,//图片资源
        //进房闪的小星星
        val special_sao: String?,
        //进房滚动光效
        val special_icon: String?,
        val badge_id: String?,//徽章id
        val dan: ActivityInformation.DanBean?,
        val priceInfo:List<BuyTimeList>?,
        val nameplate_img:String?,//资料卡背景
        val nameplate_frame:String?,//资料卡frame
        val chat_bg_position:String?,//聊天气泡的图片显示规则
        val chat_bg_id:String?,//聊天气泡的key
        val chat_path: List<String>?,//聊天气泡的key
        val tips: String?,//购买限制文案
        val is_resources: Int //是否有视频资源
) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readParcelable(ActivityInformation.DanBean::class.java.classLoader),
            parcel.createTypedArrayList(BuyTimeList),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.createStringArrayList(),
            parcel.readString(),
            parcel.readInt()) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(addtime)
        parcel.writeString(credit_level)
        parcel.writeString(day)
        parcel.writeString(desc)
        parcel.writeString(end_time)
        parcel.writeString(equalname)
        parcel.writeString(explain)
        parcel.writeString(frame_id)
        parcel.writeString(id)
        parcel.writeString(gid)
        parcel.writeInt(is_new_status)
        parcel.writeString(link)
        parcel.writeString(name)
        parcel.writeString(price)
        parcel.writeString(ratio)
        parcel.writeString(sort)
        parcel.writeString(source)
        parcel.writeString(start_time)
        parcel.writeString(status)
        parcel.writeInt(type)
        parcel.writeInt(state)
        parcel.writeString(url)
        parcel.writeString(usertype)
        parcel.writeString(wealth_level)
        parcel.writeString(labelstr)
        parcel.writeString(background)
        parcel.writeInt(is_fast_expiration)
        parcel.writeInt(isactive)
        parcel.writeString(deadLine)
        parcel.writeString(surplus)
        parcel.writeString(imgurl)
        parcel.writeString(special_sao)
        parcel.writeString(special_icon)
        parcel.writeString(badge_id)
        parcel.writeParcelable(dan, flags)
        parcel.writeTypedList(priceInfo)
        parcel.writeString(nameplate_img)
        parcel.writeString(nameplate_frame)
        parcel.writeString(chat_bg_position)
        parcel.writeString(chat_bg_id)
        parcel.writeStringList(chat_path)
        parcel.writeString(tips)
        parcel.writeInt(is_resources)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<DressUpGoods> {
        override fun createFromParcel(parcel: Parcel): DressUpGoods {
            return DressUpGoods(parcel)
        }

        override fun newArray(size: Int): Array<DressUpGoods?> {
            return arrayOfNulls(size)
        }
    }

}