package com.ninexiu.sixninexiu.bean

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/11/25
 *     desc   : 用户回归领取专属特权数据类
 *     version: 1.0
 * </pre>
 */
data class UserReturnFreeBagResult(
        val data : UserReturnFreeBagData?
) : BaseResultInfo()

data class UserReturnFreeBagData(
        val userInfo : UserReturnInfo,
        val giftInfo : MutableList<GiftReturnItem>
)

data class UserReturnInfo(
        val nickname : String?,
        val leave_days : Long
)

data class GiftReturnItem(
        val name : String,
        val img : String
)