package com.ninexiu.sixninexiu.bean


/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/29
 *     desc   :
 *     version: 1.0
 * </pre>
 */
data class ZhiFuResult(
    val code: Int,
    val data: Data?,
    val message: String?
)

data class Data(
    val agreement_name: String?,
    val allow_other_money: Int,
    val banners: MutableList<Banner>?,
    val forbid_tip: String?,
    val options: MutableList<Option>?,
    val recharge_agreement: String?,
    val show_agreement : Int = 0,
    val tips: String?,
    val user_info: UserInfo?,
    val goldenFall:Int
)

data class Banner(
    val act_url: String?,
    val banner: String?,
    val name: String?,
    val alert_banner : String?
)

data class Option(
    val amount: Int,
    val money: Int,
    val type : String,      // 支付页面为 index ， 快捷支付为 alert
    val itemType : Int,
    var selected : Boolean
)

data class UserInfo(
    val credit: String?,
    val money: String?,
    val tokencoin: String?,
    val uid: String?,
    val wealth: String?
)