package com.ninexiu.sixninexiu.common

/**
 * <pre>
 *     @author : gh
 *     time   : 2020/12/30 0030
 *     desc   : 临时缓存一些变量
 *     version: 1.0
 * </pre>
 */
public class AppCacheData private constructor() {
    companion object {
        val instance: AppCacheData by lazy(mode = LazyThreadSafetyMode.SYNCHRONIZED) {
            AppCacheData() }
    }

    /**
     * 消息列表推送权限是否点击了关闭 1- 不显示  ；0- 显示
     */
    var messagePushCloseStatus:Int = 0



    /**
     * 关注列表推送权限是否点击了关闭  1- 不显示  ；0- 显示
     */
    var attentionPushCloseStatus:Int = 0





}




