package com.ninexiu.sixninexiu.common.util.CountTechnology

/**
 *
 * @CreateDate: 2021/5/12 15:58
 * @Author:     wangyu
 * @Description: 数数科技事件名称
 * @Version:    1.0
 */
class TDEventName {

    companion object {

        /* --------------------------------------------事件数据名称-------------------------------------------- */

        /**
         * 新设备用户设备上报
         */
        //新增设备
        const val DEVICE_FIRST = "DEVICE_FIRST"

        /**
         * 直播间内
         */
        //直播间开启新手引导
        const val LIVEROOM_STARTGUIDE = "guide_complete"
        //进入直播间
        const val ENTER_LIVEROOM = "enter_stage"
        //离开直播间
        const val OUT_LIVEROOM = "stage_completed"
        //发送聊天消息
        const val SEND_LIVE_MESSAGE = "send_live_message"
        //用户登录累计时长
        const val CURRENT_SESSION_TIME = "current_session_time"
        //消消乐游戏
        const val PALY_XIAOXIAOLE = "play_xiaoxiaole"


        /* --------------------------------------------底部table按钮名称事件-------------------------------------------- */
        //首页table
        const val TD_LIVE = "Live_click"
        //发现table
        const val TD_FIND = "Find_click"
        //消息table
        const val TD_NEWS = "News_click"
        //关注table
        const val TD_CONCERN = "Concern_click"
        //我的table
        const val TD_MINE = "Mine_click"

        /* --------------------------------------------功能模块数据名称(离开“直播”TAB栏)-------------------------------------------- */
        //搜索
        const val LIVE_SEARCH = "Live_Search"
        //历史播放
        const val LIVE_HISTORY_PLAY = "Live_History_play"
        //热门
        const val LIVE_HOT = "Live_Hot"
        //交友
        const val LIVE_FRIEND = "Live_Friend"
        //附近
        const val LIVE_NEARBY = "Live_Nearby"
        //停留时长
        const val LIVE_WARTH_DUATION = "Live_Hot_01"
        //热门浏览主播数
        const val LIVE_HOT_ANTHOR_NUMBER = "Live_Hot_02"
        //正能量
        const val POSITIVE_ENERGY = "Live_Hot_03"
        //音乐
        const val LIVE_MUSIC = "Live_Hot_04"
        //舞蹈
        const val LIVE_DANCE = "Live_Hot_05"
        //娱乐
        const val LIVE_RECREATION = "Live_Hot_06"
        //校园
        const val LIVE_CAMPUS = "Live_Hot_07"
        //更多推荐
        const val LIVE_MORE_RECOMMEND = "Live_Hot_10"
        //更多新晋
        const val LIVE_MORE_NEWANTHOR = "Live_Hot_11"
        //更多“热门”点击次数
        const val LIVE_MORE_HOT = "Live_Hot_12"

        //交友页面停留时长
        const val LIVE_FRIEND_WARTH_DUATION = "Live_Friend_01"
        //交友页面浏览主播数
        const val LIVE_FRINED_ANTHOR_NUMBER = "Live_Friend_02"
        //今日主持榜点击次数
        const val LIVE_HOST_LIST = "Live_Friend_03"
        //附近页停留时长
        const val LIVE_NEARBY_WARTH_DUATION = "Live_Nearby_01"
        //附近浏览主播数
        const val LIVE_NEARBY_ANTHOR_NUMBER = "Live_Nearby_02"

        /* --------------------------------------------功能模块数据名称(离开“发现”TAB栏)-------------------------------------------- */

        //发表按钮
        const val FIND_PUBLISH = "Find_Publish"
        //“推荐”
        const val FIND_RECOMMEND = "Find_Recommend"
        //“发现”
        const val FIND_FIND = "Find_Find"
        //“排行榜”
        const val FIND_LEADERBOARD = "Find_List"
        //推荐停留时长
        const val FIND_RECOMMEND_WARTH_DUATION = "Find_Recommend_01"
        //浏览动态数
        const val FIND_DYNAMIC_NUMBER = "Find_Recommend_02"
        //新晋
        const val FIND_NEWCOMER = "Find_Find_01"
        //家族
        const val FIND_FAMILY = "Find_Find_02"
        //活动
        const val FIND_ACTIVITY = "Find_Find_03"

        /* --------------------------------------------功能模块数据名称(离开“关注”TAB栏)-------------------------------------------- */

        //关注-关注
        const val ATTENTION_CONCERN = "Concern_Concern"
        //关注-动态
        const val ATTENTION_DYNAMIC = "Concern_Monment"
        //关注-搜索
        const val ATTENTION_SEARCH = "Concern_Search"


        /* --------------------------------------------功能模块数据名称(离开“我的”TAB栏)-------------------------------------------- */

        //我的-个人主页
        const val MINE_MINE = "Mine_Mine"
        //我的-支付页面
        const val MINE_RECHARGE = "Mine_Recharge"
        //我的-道具商城
        const val MINE_PROPS_MALL = "Mine_Props_mall"
        //我的-客服中心
        const val MINE_HELP = "Mine_Help"


        /* --------------------------------------------功能模块数据名称(离开“离开直播间页”)-------------------------------------------- */


        //是否通过直播间视频缩略进入
        const val Live_Room_01 = "Live_Room_01"
        //直播间房间号
        const val Live_Room_ROOMID = "Live_Room_02"
        //直播间所在频道
        const val Live_Room_CHANLE = "Live_Room_03"
        //直播间类型
        const val Live_Room_ROOMTYPE = "Live_Room_04"
        //公聊按钮点击次数
        const val LIVE_ROOM_PUBLIC_CHAT  = "Live_Room_05"
        //私聊按钮点击次数
        const val LIVE_ROOM_PRIVATE_CHAT = "Live_Room_06"
        //菜单按钮点击次数
        const val LIVE_ROOM_MENU = "Live_Room_07"
        //任务按钮点击次数
        const val Live_Room_TASK = "Live_Room_08"
        //全屏播放按钮点击次数
        const val LIVE_ROOM_FULL_SCREEN  = "Live_Room_09"
        //上麦按钮点击次数
        const val LIVE_ROOM_SERVING_WHEAT  = "Live_Room_10"
        //礼物按钮点击次数
        const val Live_Room_GIFT = "Live_Room_11"
        //发言界面-发送按钮点击次数
        const val LIVE_ROOM_SEND = "Live_Room_12"
        //发言界面-发言成功次数
        const val LIVE_ROOM_SEND_SUCCESS = "Live_Room_13"
        //发言界面-快捷文本点击次数
        const val LIVE_ROOM_SEND_FAST = "Live_Room_14"
        //首充活动-icon点击次数
        const val Live_Room_FirstRECHARGE  = "Live_Room_15"
        //一元礼包-icon点击次数
        const val LIVE_ROOM_ONEPACKAGE = "Live_Room_16"
        //左滑隐藏-滑动次数
        const val LIVE_ROOM_SWIPELEFT_NUMBER  = "Live_Room_17"
        //左滑隐藏-停留时长
        const val LIVE_ROOM_SWIPELEFT_TIME = "Live_Room_18"
        //当前主播名片-点击次数
        const val Live_Room_ANTHORCARD = "Live_Room_19"
        //当前主播名片-“打招呼”点击次数
        const val Live_Room_ANTHORCARD_GREET = "Live_Room_20"
        //当前主播名片-“主页入口”点击次数
        const val Live_Room_ANTHORCARD_DATA = "Live_Room_21"
        //在线用户列表点击次数
        const val LIVE_ROOM_ONLINEBTN = "Live_Room_22"
        //“关闭”按钮点击次数
        const val LIVE_ROOM_CLOSEBTN = "Live_Room_23"
        //上下滑动切换直播间次数
        const val LIVE_ROOM_UPANDDOWN  = "Live_Room_24"
    }
}