package com.ninexiu.sixninexiu.common.util

import android.animation.ObjectAnimator
import android.view.View
import android.view.animation.AlphaAnimation
import android.view.animation.Animation
import android.view.animation.ScaleAnimation
import com.ninexiu.sixninexiu.common.util.VoiceGameSvgHelper.Tag
import com.ninexiu.sixninexiu.view.setVisible
import com.opensource.svgaplayer.SVGAParser
import com.opensource.svgaplayer.SVGAVideoEntity

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/09/14
 *     desc   : todo : 后期待优化，软引用
 *     version: 1.0
 *
 * </pre>
 */
object VoiceGameAnimationHelper {
    const val Tag = "VoiceGameAnimationHelper : "

    // 透明动画 : 团战pk条(淡入淡出) ， 团战图标(放大透明消失)
    fun doAlphaAnimation(view: View?, endShow: Boolean) {   // ,onFinish : (()->Unit)? = null
        view ?: return
        val alphaAnimation = AlphaAnimation(if (endShow) 0f else 1f, if (endShow) 1f else 0f)
        alphaAnimation.duration = 300
        alphaAnimation.fillAfter = false
        alphaAnimation.setAnimationListener(object : Animation.AnimationListener {
            override fun onAnimationStart(animation: Animation?) {
            }

            override fun onAnimationEnd(animation: Animation?) {
                view.setVisible(endShow)
                view.clearAnimation()
                // onFinish?.invoke()
            }

            override fun onAnimationRepeat(animation: Animation?) {
            }

        })
        view.startAnimation(alphaAnimation)
    }
}


