package com.ninexiu.sixninexiu.values

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/23
 *     desc   : 通用dialog参数
 *     version: 1.0
 * </pre>
 */
object DynamicTitleType {
    /**
     * 一级title
     */
    const val DYNAMIC_TITLE_ONE_FIND = "find"     // 发现
    const val DYNAMIC_TITLE_ONE_DYNAMIC = "dynamic"     // 动态
    const val DYNAMIC_TITLE_ONE_SHORT_VIDEO = "video_short"     // 短视频
    const val DYNAMIC_TITLE_ONE_RANK = "rank"     // 排行榜

    /**
     * 二级title
     */
    const val DYNAMIC_TITLE_TWO_FIND_NEW = "new"     // 发现-新晋
    const val DYNAMIC_TITLE_TWO_FIND_FAMLIY = "famliy"     // 发现-家族
    const val DYNAMIC_TITLE_TWO_FIND_ACTIVE = "activity"     // 发现-活动


    const val DYNAMIC_TITLE_TWO_RANK_STAR = "star"     // 排行榜-明星
    const val DYNAMIC_TITLE_TWO_RANK_RICH = "rich"     // 排行榜-富豪
    const val DYNAMIC_TITLE_TWO_RANK_PK = "pk"     // 排行榜-pk
    const val DYNAMIC_TITLE_TWO_RANK_CHARM = "charm"     // 排行榜-魅力
}