package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.bean.GiftWeekItem
import kotlinx.android.synthetic.main.include_gift_week.view.*

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/06/17
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class GiftWeekView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.include_gift_week, this)
    }

    fun setWeekInfo(info: GiftWeekItem?) {
        this.visibility = if (info == null) {
            View.INVISIBLE
        } else {
            View.VISIBLE
        }

        weekAnchorName?.text = info?.anchornick
        weekUserName?.text = info?.usernick
    }
}