package com.ninexiu.sixninexiu.common.util

import android.content.Context
import android.util.AttributeSet
import android.view.MotionEvent
import com.google.android.material.textfield.TextInputEditText

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/16
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class MBInputEditText : TextInputEditText{
    constructor(context: Context) : super(context) {
    }

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs) {
    }

    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {
    }

    var getFocus : (()-> Unit)? = null

    override fun onTouchEvent(event: MotionEvent?): Boolean {
        when(event?.action) {
            MotionEvent.ACTION_UP -> {
                // 在键盘出现前使得view消失
                getFocus?.invoke()
            }
        }
        return super.onTouchEvent(event)
    }
}

