package com.ninexiu.sixninexiu.view

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import kotlinx.android.synthetic.main.view_suit_gift_worship.view.*

/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/08/10
 *     desc   : 套装礼物 膜拜view
 *     version: 1.0
 * </pre>
 */
class SuitGiftWorshipView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0) : ConstraintLayout(context, attrs, defStyleAttr) {
    init {
        LayoutInflater.from(context).inflate(R.layout.view_suit_gift_worship, this)
        refreshView()
    }


    fun setCountDownText(text: String) {
        tv_worship_time.text = text
    }

    fun refreshView(){
        if (AppCnfSpHelper.getInstance().worshipStatus) {
            group_worship.visibility = View.VISIBLE
            worshipGuide.visibility = View.GONE
        } else {
            group_worship.visibility = View.GONE
            worshipGuide.visibility = View.VISIBLE
        }
    }
}
