package com.ninexiu.sixninexiu.view.dialog

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Handler
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.PopupWindow
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.ConfigSpHelper
import com.ninexiu.sixninexiu.common.util.NSLog
import com.ninexiu.sixninexiu.common.util.TimeUtil
import com.ninexiu.sixninexiu.view.UserReturnGsonHelper
import com.ninexiu.sixninexiu.view.dp2px
import com.ninexiu.sixninexiu.view.fitterViewSize
import com.ninexiu.sixninexiu.view.getScreenWidth
import com.ninexiu.sixninexiu.view.popwindow.BasePopupWindow

/**
 * <pre>
 *     @author : hpf
 *     time   : 2021/05/17
 *     version: 1.0
 * </pre>
 */
@SuppressLint("SetTextI18n")
class AutumnRulePopWindow(context: Context) : PopupWindow(context) {

    @SuppressLint("InflateParams")
    var view: View = LayoutInflater.from(context).inflate(R.layout.layout_autumn_rule_pop, null, false)

    init {
        val tvRule = view.findViewById<TextView>(R.id.tvRule)
        tvRule.text =
                """活动期间，未充值过得新用户绑定手机号后即可购买对应充值礼包，每个礼包仅可购买1次

注:

1.活动期间布衣用户可购买10000元礼包，礼包中的男爵直通车可使财富等级可直接升至男爵

2.包裹礼物领取后7日内有效

3.本次活动解释权归九秀直播所有"""

        contentView = view

        val widthScreen = getScreenWidth(context)

        this.width = (0.7014 * widthScreen).toInt()
        this.height = ViewGroup.LayoutParams.WRAP_CONTENT
        val container = view.findViewById<ConstraintLayout>(R.id.containerConstraint)
        container.post {
            fitterViewSize(container, { (0.624 * widthScreen).toInt() })
        }
        this.isFocusable = true
        val dw = ColorDrawable(Color.TRANSPARENT)
        setBackgroundDrawable(dw)
    }
}