package com.ninexiu.sixninexiu.view.dialog

import android.content.Context
import android.content.Intent
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.activity.AdvertiseActivity
import com.ninexiu.sixninexiu.common.AppCnfSpHelper
import com.ninexiu.sixninexiu.common.util.Constants
import kotlinx.android.synthetic.main.dialog_eight_years_remind.*

/**
 * <pre>
 *     @author : bing
 *     time   : 2021/9/26
 *     desc   : 八周年回忆引导弹窗
 *     version: 1.0
 * </pre>
 */
class EightYearsRemindDialog(val mContext: Context) :BaseDialog(mContext) {
    override fun getContentView(): Int {
        return R.layout.dialog_eight_years_remind
    }

    companion object{
        fun create(context: Context):EightYearsRemindDialog{
            return EightYearsRemindDialog(context)
        }
    }


    override fun initView() {
        super.initView()
        iv_eight_years_start?.setOnClickListener {
            AppCnfSpHelper.getInstance().set8YearsState(2)
            // 跳转广告页
            val intent = Intent(mContext, AdvertiseActivity::class.java)
            intent.putExtra("url", Constants.EIGHT_YEARS_MEMORT) //H5页面的链接
            intent.putExtra("isFullScreen", true) //是否是没有titilebar （全屏）
            mContext.startActivity(intent)
            dismiss()
        }
    }
}