package com.ninexiu.sixninexiu.view.dialog

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.PopupWindow
import android.widget.TextView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.DensityUtil


/**
 * <pre>
 *     @author : hetao
 *     time   : 2021/05/21
 *     desc   : 首冲提示
 *     version: 1.0
 * </pre>
 */
class FirstRechargeTipPopWindow(context: Context) : PopupWindow(context) {
    private var tipText: TextView? = null

    @SuppressLint("InflateParams")
    var view: View = LayoutInflater.from(context).inflate(R.layout.layout_first_recharge_pop, null, false)

    init {
        tipText = view.findViewById(R.id.first_recharge_tip)
        contentView = view

        this.width = ViewGroup.LayoutParams.WRAP_CONTENT
        this.height = ViewGroup.LayoutParams.WRAP_CONTENT
        this.isFocusable = true
        val dw = ColorDrawable(Color.TRANSPARENT)
        setBackgroundDrawable(dw)
    }

    fun showCustom(view: View?, tip: String?) {
        tipText?.text = tip
        showAsDropDown(view, 0, -DensityUtil.dp2px(view?.context, 67F + 29F))
    }

}