package com.ninexiu.sixninexiu.view.dialog

import android.app.Dialog
import android.content.Context
import android.view.Gravity
import android.view.LayoutInflater
import android.view.ViewGroup
import android.view.WindowManager
import com.ninexiu.sixninexiu.R
import kotlinx.android.synthetic.main.dialog_parentsmodlehintdialog.dialog_tv_parents_know

/**
 * author wangyu
 * date: on 2019/10/15 0015
 * describe: 家长模式提醒弹窗
 */
class ParentsModleHintDialog: Dialog{

    constructor(context: Context) : this(context,0)
    constructor(context: Context, themeResId: Int) : super(context, R.style.AlertDialogStyle){
        val view = LayoutInflater.from(context).inflate(R.layout.dialog_parentsmodlehintdialog, null)
        setContentView(view)
        dialog_tv_parents_know.setOnClickListener {
            dismiss()
        }
        setContentView(view)
        window?.setGravity(Gravity.CENTER)
        window?.setLayout(getWidth() / 8 * 6, ViewGroup.LayoutParams.WRAP_CONTENT)
    }

    fun getWidth(): Int {
        val wm = context.getSystemService(Context.WINDOW_SERVICE) as WindowManager
        return wm.defaultDisplay.width
    }

}