package com.ninexiu.sixninexiu.view.dialog

import android.app.Activity
import android.content.Context
import com.ninexiu.sixninexiu.R

/**
 * <pre>
 *     @author : hpf
 *     time   : 2020/12/29
 *     desc   : 通用用户加载框
 *     version: 1.0
 * </pre>
 */
object ProgressDialogUtil {
    private var dialog: ProgressDialog? = null

    fun show(context: Context) {
        if (context is Activity && null != context.window) {
            dialog = ProgressDialog(context)
            dialog?.show()
        }
    }

    fun dismiss() {
        dialog?.dismiss()
        dialog = null
    }
}


class ProgressDialog constructor(context: Context) : BaseDialog(context) {

    override fun getContentView(): Int {
        return R.layout.dialog_progress
    }

    override fun setOnBackgroundDismiss() = false

    override fun setBackgroundDimAlpha() = 0f
}