package com.ninexiu.sixninexiu.view.popwindow

import android.content.Context
import android.view.View
import android.widget.ImageView
import com.ninexiu.sixninexiu.R
import com.ninexiu.sixninexiu.common.util.Utils

/**
 * 隐身卡介绍的pop
 *
 * @author wangyu
 * @date 2020/8/28
 */
class StorePropYinshenPopWindow private constructor(private val mContext: Context) : BasePopupWindow<StorePropYinshenPopWindow>() {

    companion object {
        fun create(context: Context): StorePropYinshenPopWindow {
            return StorePropYinshenPopWindow(context)
        }
    }

    override fun initAttributes() {
        setContentView(R.layout.popwindow_store_prop_yinshen)
        setFocusAndOutsideEnable(true)
    }

    override fun initEvents() {
        super.initEvents()
    }

    init {
        setContext(mContext)
    }

    override fun initViews(view: View?, popup: StorePropYinshenPopWindow?) {
        view?.findViewById<ImageView>(R.id.iv_close)?.setOnClickListener {
            dismiss()
        }
    }
}